' ----------------------------------------------------------------------------------------
'
' HanoiRob.VB                                                       Ulrich Mller 12.10.03
'                                                                   PCS1700   VB.NET Final
' Lsung der "Turm von Hanoi Problems mit einem Roboter
' Klasse HanoiRob : Robotnahe Methoden
'
' ----------------------------------------------------------------------------------------

Imports FishFa30

Public Class HanoiRob
  Inherits FishFa30.FishFace

  Public mSaule As Integer = 1
  Public mArm As Integer = 2
  Public mGreifer As Integer = 3
  Public eArmOben As Integer = 3
  Public eArmUnten As Integer = 4
  Public PosA As Integer = 30
  Public PosB As Integer = 75
  Public PosC As Integer = 120

  Private RobotPos As Integer = 999

  Public Sub Grundstellung()
    SetMotor(mGreifer, Dir.Aus)
    ArmHeben()
    RobotPos = 999
    SauleNach(0)
    SauleNach(PosA)
  End Sub

  Public Sub SauleNach(ByVal ZielPos%)
    If RobotPos < ZielPos Then
      SetMotor(mSaule, Dir.Rechts, Speed.Full, ZielPos - RobotPos)
      WaitForMotors(0, mSaule)
    Else
      SetMotor(mSaule, Dir.Links, Speed.Full, RobotPos - ZielPos)
      WaitForMotors(0, mSaule)
    End If
    RobotPos = ZielPos + GetCounter((mSaule - 1) * 2 + 2)
  End Sub

  Public Sub ArmSenken()
    SetMotor(mArm, Dir.Links)
    WaitForInput(eArmUnten)
    SetMotor(mArm, Dir.Aus)
  End Sub

  Public Sub ArmHeben()
    SetMotor(mArm, Dir.Rechts)
    WaitForInput(eArmOben)
    SetMotor(mArm, Dir.Aus)
  End Sub

  Public Sub ScheibeLegen()
    SetMotor(mGreifer, Dir.Aus)
  End Sub

  Public Sub ScheibeGreifen()
    SetMotor(mGreifer, Dir.Ein)
  End Sub

End Class
