// -------------------------------------------------------------------------------------
//
// HanoiMain.CS                                                   Ulrich Mller 13.10.03
//                                                                PCS1700  C#.NET  Final
// Lsung des "Turm von Hanoi" Problems mit einem Roboter
//
// -------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using FishFa30;

namespace HanoiRobot
{
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.PictureBox pictureBox2;
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.Button cmdAction;
		private System.Windows.Forms.Button cmdEnde;
		private System.Windows.Forms.ComboBox cboPortName;
		private System.Windows.Forms.NumericUpDown numScheiben;
		private System.Windows.Forms.Label label1;
		private System.ComponentModel.Container components = null;

		public frmMain()
		{
			InitializeComponent();
			cboPortName.SelectedIndex = 2;
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMain));
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.pictureBox2 = new System.Windows.Forms.PictureBox();
			this.lblStatus = new System.Windows.Forms.Label();
			this.cmdAction = new System.Windows.Forms.Button();
			this.cmdEnde = new System.Windows.Forms.Button();
			this.cboPortName = new System.Windows.Forms.ComboBox();
			this.numScheiben = new System.Windows.Forms.NumericUpDown();
			this.label1 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.numScheiben)).BeginInit();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Bitmap)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(32, 40);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(240, 304);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// pictureBox2
			// 
			this.pictureBox2.Image = ((System.Drawing.Bitmap)(resources.GetObject("pictureBox2.Image")));
			this.pictureBox2.Location = new System.Drawing.Point(384, 48);
			this.pictureBox2.Name = "pictureBox2";
			this.pictureBox2.Size = new System.Drawing.Size(32, 32);
			this.pictureBox2.TabIndex = 1;
			this.pictureBox2.TabStop = false;
			// 
			// lblStatus
			// 
			this.lblStatus.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblStatus.Location = new System.Drawing.Point(32, 360);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(240, 24);
			this.lblStatus.TabIndex = 2;
			this.lblStatus.Text = "Anschlu prfen - START Button";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// cmdAction
			// 
			this.cmdAction.Location = new System.Drawing.Point(304, 352);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(112, 32);
			this.cmdAction.TabIndex = 3;
			this.cmdAction.Text = "&START";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// cmdEnde
			// 
			this.cmdEnde.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdEnde.Location = new System.Drawing.Point(304, 312);
			this.cmdEnde.Name = "cmdEnde";
			this.cmdEnde.Size = new System.Drawing.Size(112, 32);
			this.cmdEnde.TabIndex = 4;
			this.cmdEnde.Text = "&Abbrechen";
			this.cmdEnde.Click += new System.EventHandler(this.cmdEnde_Click);
			// 
			// cboPortName
			// 
			this.cboPortName.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboPortName.Items.AddRange(new object[] {
															 "LPT",
															 "COM1",
															 "COM2",
															 "COM3",
															 "COM4"});
			this.cboPortName.Location = new System.Drawing.Point(304, 272);
			this.cboPortName.Name = "cboPortName";
			this.cboPortName.Size = new System.Drawing.Size(112, 21);
			this.cboPortName.TabIndex = 5;
			// 
			// numScheiben
			// 
			this.numScheiben.Location = new System.Drawing.Point(376, 232);
			this.numScheiben.Maximum = new System.Decimal(new int[] {
																		99,
																		0,
																		0,
																		0});
			this.numScheiben.Minimum = new System.Decimal(new int[] {
																		1,
																		0,
																		0,
																		0});
			this.numScheiben.Name = "numScheiben";
			this.numScheiben.Size = new System.Drawing.Size(40, 20);
			this.numScheiben.TabIndex = 6;
			this.numScheiben.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.numScheiben.Value = new System.Decimal(new int[] {
																	  3,
																	  0,
																	  0,
																	  0});
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(304, 232);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 16);
			this.label1.TabIndex = 7;
			this.label1.Text = "Scheiben";
			// 
			// frmMain
			// 
			this.AcceptButton = this.cmdAction;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdEnde;
			this.ClientSize = new System.Drawing.Size(448, 405);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.numScheiben,
																		  this.cboPortName,
																		  this.cmdEnde,
																		  this.cmdAction,
																		  this.lblStatus,
																		  this.pictureBox2,
																		  this.pictureBox1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "frmMain";
			this.Text = "C#.NET : Turm von Hanoi";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmMain_Closing);
			((System.ComponentModel.ISupportInitialize)(this.numScheiben)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		private HanoiRob hr = new HanoiRob();

		private void Hanoi(int n, int TAnf, int TMit, int TEnd)
		{
			if(n == 1) 
			{
				lblStatus.Text = String.Format("Scheibe von {0:#00} -> {1:#00}", TAnf, TEnd);
				Ziehe(TAnf, TEnd);
			}
			else 
			{
				Hanoi(n-1, TAnf, TEnd, TMit);
				lblStatus.Text = String.Format("Scheibe von {0:#00} -> {1:#00}", TAnf, TEnd);
				Ziehe(TAnf, TEnd);
				Hanoi(n-1, TMit, TAnf, TEnd);
			}
		}

		private void Ziehe(int Von, int Nach)
		{
			Hole(Von);
			Bringe(Nach);
		}

		private void Hole(int Pos)
		{
			hr.SauleNach(Pos);
			hr.ArmSenken();
			hr.ScheibeGreifen();
			hr.ArmHeben();
		}

		private void Bringe(int Pos)
		{
		    hr.SauleNach(Pos);
			hr.ArmSenken();
			hr.ScheibeLegen();
			hr.ArmHeben();
		}
		
		private void frmMain_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if(cmdEnde.Text == "&HALT") e.Cancel = true;
		}

		private void cmdEnde_Click(object sender, System.EventArgs e)
		{
			if(cmdEnde.Text == "&HALT") hr.NotHalt = true; this.Close();
		}

		private void cmdAction_Click(object sender, System.EventArgs e)
		{
			try
			{
				hr.OpenInterface(cboPortName.SelectedIndex);
				cmdAction.Enabled = false;
				cmdEnde.Text      = "&HALT";
				lblStatus.Text    = "luft";
				cmdEnde.Focus();

				lblStatus.Text = "Fhrt auf Grundstellung";
				hr.Grundstellung();
				Hanoi((int)numScheiben.Value, hr.PosA, hr.PosB, hr.PosC);
				hr.Grundstellung();
				lblStatus.Text = "--- FINIS ---";

				hr.ClearMotors();
			}
			catch(FishFaceException eft)
			{
				lblStatus.Text = eft.Message;
				hr.NotHalt     = true;
			}
			finally
			{
				cmdAction.Enabled = true;
				cmdEnde.Text      = "&ENDE";
				hr.CloseInterface();
			}
		}

	}
}
