' ----------------------------------------------------------------------------------------
'
' HanoiMain.VB                                                      Ulrich Mller 12.10.03
'                                                                   PCS1700   VB.NET Final
' Lsung der "Turm von Hanoi Problems mit einem Roboter
'
' ----------------------------------------------------------------------------------------

Imports FishFa30

Public Class frmMain
  Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

  Public Sub New()
    MyBase.New()

    ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
    InitializeComponent()

    ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

  End Sub

  ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
  Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
    If disposing Then
      If Not (components Is Nothing) Then
        components.Dispose()
      End If
    End If
    MyBase.Dispose(disposing)
  End Sub

  ' Fr Windows Form-Designer erforderlich
  Private components As System.ComponentModel.IContainer

  'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
  'Sie kann mit dem Windows Form-Designer modifiziert werden.
  'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
  Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
  Friend WithEvents cmdAction As System.Windows.Forms.Button
  Friend WithEvents cmdEnde As System.Windows.Forms.Button
  Friend WithEvents cboPortName As System.Windows.Forms.ComboBox
  Friend WithEvents lblStatus As System.Windows.Forms.Label
  Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
  Friend WithEvents txtScheiben As System.Windows.Forms.TextBox
  Friend WithEvents Label1 As System.Windows.Forms.Label
  <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
    Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(frmMain))
    Me.PictureBox1 = New System.Windows.Forms.PictureBox()
    Me.cmdAction = New System.Windows.Forms.Button()
    Me.cmdEnde = New System.Windows.Forms.Button()
    Me.cboPortName = New System.Windows.Forms.ComboBox()
    Me.lblStatus = New System.Windows.Forms.Label()
    Me.PictureBox2 = New System.Windows.Forms.PictureBox()
    Me.txtScheiben = New System.Windows.Forms.TextBox()
    Me.Label1 = New System.Windows.Forms.Label()
    Me.SuspendLayout()
    '
    'PictureBox1
    '
    Me.PictureBox1.Image = CType(resources.GetObject("PictureBox1.Image"), System.Drawing.Bitmap)
    Me.PictureBox1.Location = New System.Drawing.Point(64, 48)
    Me.PictureBox1.Name = "PictureBox1"
    Me.PictureBox1.Size = New System.Drawing.Size(232, 304)
    Me.PictureBox1.TabIndex = 0
    Me.PictureBox1.TabStop = False
    '
    'cmdAction
    '
    Me.cmdAction.Location = New System.Drawing.Point(328, 352)
    Me.cmdAction.Name = "cmdAction"
    Me.cmdAction.Size = New System.Drawing.Size(104, 32)
    Me.cmdAction.TabIndex = 1
    Me.cmdAction.Text = "&START"
    '
    'cmdEnde
    '
    Me.cmdEnde.Location = New System.Drawing.Point(328, 304)
    Me.cmdEnde.Name = "cmdEnde"
    Me.cmdEnde.Size = New System.Drawing.Size(104, 32)
    Me.cmdEnde.TabIndex = 2
    Me.cmdEnde.Text = "&Abbrechen"
    '
    'cboPortName
    '
    Me.cboPortName.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
    Me.cboPortName.Items.AddRange(New Object() {"LST", "COM1", "COM2", "COM3", "COM4"})
    Me.cboPortName.Location = New System.Drawing.Point(328, 256)
    Me.cboPortName.Name = "cboPortName"
    Me.cboPortName.Size = New System.Drawing.Size(104, 21)
    Me.cboPortName.TabIndex = 3
    '
    'lblStatus
    '
    Me.lblStatus.Font = New System.Drawing.Font("Tahoma", 11.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.lblStatus.Location = New System.Drawing.Point(64, 368)
    Me.lblStatus.Name = "lblStatus"
    Me.lblStatus.Size = New System.Drawing.Size(232, 24)
    Me.lblStatus.TabIndex = 4
    Me.lblStatus.Text = "Anschlu prfen - START Button"
    Me.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
    '
    'PictureBox2
    '
    Me.PictureBox2.Image = CType(resources.GetObject("PictureBox2.Image"), System.Drawing.Bitmap)
    Me.PictureBox2.Location = New System.Drawing.Point(392, 48)
    Me.PictureBox2.Name = "PictureBox2"
    Me.PictureBox2.Size = New System.Drawing.Size(40, 40)
    Me.PictureBox2.TabIndex = 5
    Me.PictureBox2.TabStop = False
    '
    'txtScheiben
    '
    Me.txtScheiben.Location = New System.Drawing.Point(408, 220)
    Me.txtScheiben.Name = "txtScheiben"
    Me.txtScheiben.Size = New System.Drawing.Size(24, 20)
    Me.txtScheiben.TabIndex = 6
    Me.txtScheiben.Text = "3"
    Me.txtScheiben.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
    '
    'Label1
    '
    Me.Label1.Location = New System.Drawing.Point(328, 224)
    Me.Label1.Name = "Label1"
    Me.Label1.Size = New System.Drawing.Size(80, 16)
    Me.Label1.TabIndex = 7
    Me.Label1.Text = "Anz. Scheiben"
    '
    'frmMain
    '
    Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
    Me.ClientSize = New System.Drawing.Size(456, 405)
    Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.Label1, Me.txtScheiben, Me.PictureBox2, Me.lblStatus, Me.cboPortName, Me.cmdEnde, Me.cmdAction, Me.PictureBox1})
    Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
    Me.MaximizeBox = False
    Me.MaximumSize = New System.Drawing.Size(464, 432)
    Me.Name = "frmMain"
    Me.Text = "VB.NET : Turm von Hanoi"
    Me.ResumeLayout(False)

  End Sub

#End Region

  Dim hr As New HanoiRob()

  Private Sub Hanoi(ByVal n%, ByVal TAnf%, ByVal TMit%, ByVal TEnd%)
    If n = 1 Then
      lblStatus.Text = String.Format("Scheibe von {0:#00} -> {1:#00}", TAnf, TEnd)
      Ziehe(TAnf, TEnd)
    Else
      Hanoi(n - 1, TAnf, TEnd, TMit)
      lblStatus.Text = String.Format("Scheibe von {0:#00} -> {1:#00}", TAnf, TEnd)
      Ziehe(TAnf, TEnd)
      Hanoi(n - 1, TMit, TAnf, TEnd)
    End If
  End Sub

  Private Sub Ziehe(ByVal Von%, ByVal Nach%)
    Hole(Von)
    Bringe(Nach)
  End Sub

  Private Sub Hole(ByVal Pos%)
    hr.SauleNach(Pos)
    hr.ArmSenken()
    hr.ScheibeGreifen()
    hr.ArmHeben()
  End Sub

  Private Sub Bringe(ByVal Pos%)
    hr.SauleNach(Pos)
    hr.ArmSenken()
    hr.ScheibeLegen()
    hr.ArmHeben()
  End Sub

  Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
    cboPortName.Text = cboPortName.Items(2)
  End Sub

  Private Sub frmMain_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
    If cmdEnde.Text = "&HALT" Then e.Cancel = True
  End Sub

  Private Sub cmdEnde_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    If cmdEnde.Text = "&HALT" Then hr.NotHalt = True Else Close()
  End Sub

  Private Sub cmdAction_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdAction.Click
    Try
      hr.OpenInterface(cboPortName.SelectedIndex)
      cmdAction.Enabled = False
      cmdEnde.Text = "&HALT"
      lblStatus.Text = "Luft"
      cmdEnde.Focus()

      lblStatus.Text = "Fhrt auf Grundstellung"
      hr.Grundstellung()
      Hanoi(txtScheiben.Text, hr.PosA, hr.PosB, hr.PosC)
      lblStatus.Text = "--- FINIS ---"

      hr.ClearMotors()
      lblStatus.Text = "START/ENDE"
      hr.CloseInterface()
    Catch eft As FishFa30.FishFaceException
      lblStatus.Text = eft.Message
      hr.NotHalt = True
    Finally
      cmdAction.Enabled = True
      cmdEnde.Text = "&ENDE"
    End Try
  End Sub
End Class
